CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build a notes app in React

A notes application is an ideal project for mastering React state management, CRUD operations, and data persistence. As the creator of CoreUI, I’ve built note-taking interfaces for knowledge management tools, CMS editors, and productivity dashboards. The most effective approach uses useState for notes, useEffect for localStorage persistence, and controlled inputs for editing. This delivers a fully functional notes app with minimal complexity.

Create the core notes state and display structure.

import { useState, useEffect } from 'react'

function NotesApp() {
  const [notes, setNotes] = useState(() => {
    const saved = localStorage.getItem('notes')
    return saved ? JSON.parse(saved) : []
  })
  const [activeId, setActiveId] = useState(null)

  useEffect(() => {
    localStorage.setItem('notes', JSON.stringify(notes))
  }, [notes])

  const createNote = () => {
    const note = { id: Date.now(), title: 'New Note', body: '', updatedAt: Date.now() }
    setNotes([note, ...notes])
    setActiveId(note.id)
  }

  const deleteNote = (id) => {
    setNotes(notes.filter(n => n.id !== id))
    if (activeId === id) setActiveId(null)
  }

  const activeNote = notes.find(n => n.id === activeId)

  return (
    <div className="notes-app">
      <aside className="sidebar">
        <button onClick={createNote}>+ New Note</button>
        <ul>
          {notes.map(note => (
            <li
              key={note.id}
              className={note.id === activeId ? 'active' : ''}
              onClick={() => setActiveId(note.id)}
            >
              <strong>{note.title || 'Untitled'}</strong>
              <button onClick={(e) => { e.stopPropagation(); deleteNote(note.id) }}>×</button>
            </li>
          ))}
        </ul>
      </aside>
      <main>
        {activeNote ? (
          <NoteEditor note={activeNote} setNotes={setNotes} notes={notes} />
        ) : (
          <p>Select a note or create a new one</p>
        )}
      </main>
    </div>
  )
}

Notes load from localStorage on mount via the useState initializer. The activeId tracks which note is open. New notes are prepended so the latest appears first. Deleting the active note clears the editor.

Building the Note Editor

Create an editor that updates notes as you type.

function NoteEditor({ note, notes, setNotes }) {
  const updateNote = (field, value) => {
    setNotes(notes.map(n =>
      n.id === note.id
        ? { ...n, [field]: value, updatedAt: Date.now() }
        : n
    ))
  }

  const formatDate = (timestamp) =>
    new Date(timestamp).toLocaleString('en-US', {
      month: 'short', day: 'numeric', hour: '2-digit', minute: '2-digit'
    })

  return (
    <div className="note-editor">
      <input
        className="note-title"
        type="text"
        value={note.title}
        onChange={(e) => updateNote('title', e.target.value)}
        placeholder="Note title"
      />
      <p className="note-meta">Last updated: {formatDate(note.updatedAt)}</p>
      <textarea
        className="note-body"
        value={note.body}
        onChange={(e) => updateNote('body', e.target.value)}
        placeholder="Start writing..."
      />
    </div>
  )
}

updateNote patches the changed field while preserving other fields. It also updates the timestamp. Changes persist to localStorage via the parent’s useEffect. The editor is fully controlled.

Adding Search Functionality

Filter notes by title and content.

function NotesApp() {
  const [notes, setNotes] = useState(() => {
    const saved = localStorage.getItem('notes')
    return saved ? JSON.parse(saved) : []
  })
  const [activeId, setActiveId] = useState(null)
  const [search, setSearch] = useState('')

  useEffect(() => {
    localStorage.setItem('notes', JSON.stringify(notes))
  }, [notes])

  const filteredNotes = notes.filter(note =>
    note.title.toLowerCase().includes(search.toLowerCase()) ||
    note.body.toLowerCase().includes(search.toLowerCase())
  )

  return (
    <div className="notes-app">
      <aside className="sidebar">
        <input
          type="text"
          value={search}
          onChange={(e) => setSearch(e.target.value)}
          placeholder="Search notes..."
        />
        <ul>
          {filteredNotes.map(note => (
            <li key={note.id} onClick={() => setActiveId(note.id)}>
              {note.title || 'Untitled'}
            </li>
          ))}
        </ul>
      </aside>
    </div>
  )
}

filteredNotes filters in real time as search changes. Both title and body are searched. The original notes array stays unchanged so clearing the search restores the full list.

Sorting Notes

Sort by last updated or alphabetically.

const [sortBy, setSortBy] = useState('updated')

const sortedNotes = [...filteredNotes].sort((a, b) => {
  if (sortBy === 'updated') return b.updatedAt - a.updatedAt
  return a.title.localeCompare(b.title)
})

Sorting creates a new array to avoid mutating state. Date sort puts recently edited notes first. Title sort uses localeCompare for correct alphabetical order. Add a dropdown to let users switch between sort modes.

Best Practice Note

This is the same notes architecture we use in CoreUI content management templates. For production apps, replace localStorage with an API backend so notes sync across devices. Add Markdown rendering with a library like react-markdown for rich formatting. Implement auto-save with a debounced useEffect to avoid excessive writes on every keystroke. Add keyboard shortcut Ctrl+N for creating new notes quickly. Consider tags or folders for organization as the notes collection grows.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build a notes app in Angular

A notes app combines CRUD operations, real-time search filtering, and rich text display in an intuitive interface that teaches essential Angular patterns. As the creator of CoreUI with Angular development experience since 2014, I use this project structure in CoreUI Angular templates as the starting point for more complex content management features. The architecture uses a reactive service with BehaviorSubject for state, the async pipe for memory-safe subscriptions, and combineLatest to derive the filtered list from both the notes array and the search query. This reactive approach avoids imperative subscription management and keeps the component template simple.

Create the notes service with reactive state.

// notes.service.ts
import { Injectable } from '@angular/core'
import { BehaviorSubject, combineLatest, map } from 'rxjs'

export interface Note {
  id: number
  title: string
  content: string
  color: string
  createdAt: Date
}

const COLORS = ['#fff9c4', '#f8bbd0', '#b3e5fc', '#c8e6c9', '#ffe0b2']

@Injectable({ providedIn: 'root' })
export class NotesService {
  private nextId = 1
  private notes$ = new BehaviorSubject<Note[]>([])
  private search$ = new BehaviorSubject<string>('')

  readonly search = this.search$.asObservable()

  readonly filteredNotes$ = combineLatest([this.notes$, this.search$]).pipe(
    map(([notes, query]) => {
      if (!query.trim()) return notes
      const q = query.toLowerCase()
      return notes.filter(n =>
        n.title.toLowerCase().includes(q) ||
        n.content.toLowerCase().includes(q)
      )
    })
  )

  add(title: string, content: string): void {
    const color = COLORS[Math.floor(Math.random() * COLORS.length)]
    const notes = [
      { id: this.nextId++, title, content, color, createdAt: new Date() },
      ...this.notes$.value
    ]
    this.notes$.next(notes)
  }

  remove(id: number): void {
    this.notes$.next(this.notes$.value.filter(n => n.id !== id))
  }

  setSearch(query: string): void {
    this.search$.next(query)
  }
}

combineLatest emits whenever either notes$ or search$ changes, deriving the filtered list reactively. The async pipe in the template subscribes and unsubscribes automatically.

Notes App Component

Build the main page with search and masonry grid layout.

// notes-app.component.ts
import { Component } from '@angular/core'
import { CommonModule } from '@angular/common'
import { ReactiveFormsModule, FormControl } from '@angular/forms'
import { CardModule, FormModule, ButtonModule, GridModule } from '@coreui/angular'
import { NotesService } from './notes.service'

@Component({
  selector: 'app-notes',
  standalone: true,
  imports: [CommonModule, ReactiveFormsModule, CardModule, FormModule, ButtonModule, GridModule],
  template: `
    <div class="mb-4 d-flex gap-3 align-items-center">
      <h1 class="mb-0">Notes</h1>
      <input cFormControl placeholder="Search notes..." [formControl]="searchControl"
        style="max-width: 300px" />
    </div>

    <!-- Add note form -->
    <c-card class="mb-4">
      <c-card-body>
        <input cFormControl [formControl]="titleControl" placeholder="Title" class="mb-2" />
        <textarea cFormControl [formControl]="contentControl" rows="3"
          placeholder="Note content..."></textarea>
        <button cButton color="primary" class="mt-2" (click)="addNote()">Add Note</button>
      </c-card-body>
    </c-card>

    <!-- Notes grid -->
    <c-row>
      <c-col sm="6" md="4" lg="3"
        *ngFor="let note of (notesService.filteredNotes$ | async)"
        class="mb-3"
      >
        <c-card [style.background]="note.color">
          <c-card-body>
            <h5>{{ note.title }}</h5>
            <p class="small">{{ note.content }}</p>
            <div class="d-flex justify-content-between align-items-center">
              <small class="text-muted">{{ note.createdAt | date:'MMM d' }}</small>
              <button cButton color="ghost" size="sm" (click)="notesService.remove(note.id)">
                ✕
              </button>
            </div>
          </c-card-body>
        </c-card>
      </c-col>
    </c-row>

    <p *ngIf="(notesService.filteredNotes$ | async)?.length === 0" class="text-muted text-center mt-4">
      No notes found.
    </p>
  `
})
export class NotesAppComponent {
  titleControl = new FormControl('')
  contentControl = new FormControl('')
  searchControl = new FormControl('')

  constructor(public notesService: NotesService) {
    this.searchControl.valueChanges.subscribe(query => {
      this.notesService.setSearch(query ?? '')
    })
  }

  addNote(): void {
    const title = this.titleControl.value?.trim()
    const content = this.contentControl.value?.trim()
    if (!title || !content) return
    this.notesService.add(title, content)
    this.titleControl.reset()
    this.contentControl.reset()
  }
}

valueChanges on the search control connects form input to the service’s search state reactively. The async pipe handles subscription and renders the filtered list automatically whenever it changes.

Best Practice Note

This is the same notes app structure used in CoreUI Angular templates as a demonstration of reactive state management. Add localStorage persistence in the service to survive page reloads. For a production notes app, connect to the notes API in Node.js backend for multi-device sync. Rich text editing can be added with a library like Quill or TipTap.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
CoreUI Vue.js components library– gimme more?
CoreUI Vue.js components library– gimme more?

CoreUI 3k+ icons set – why the … did we do this?!
CoreUI 3k+ icons set – why the … did we do this?!

Laravel rockz?
Laravel rockz?

Are you ready for CoreUI 3.0?
Are you ready for CoreUI 3.0?